cryptonite-0.23: Cryptography Primitives sink

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | stable
Portability | good
Safe Haskell | None
Language | Haskell2010

Crypto.Cipher.ChaCha

Contents

- simple interface for DRG purpose

Description

Synopsis

- initialize :: (ByteArrayAccess key, ByteArrayAccess nonce) => Int -> key -> nonce -> State
- combine :: ByteArray ba => State -> ba -> (ba, State)
- generate :: ByteArray ba => State -> Int -> (ba, State)
- data State
- initializeSimple :: ByteArray seed => seed -> StateSimple
- generateSimple :: ByteArray ba => StateSimple -> Int -> (ba, StateSimple)
- data StateSimple

# Documentation

initialize #

Arguments

:: (ByteArrayAccess key, ByteArrayAccess nonce) |
=> Int | number of rounds (8,12,20)
-> key | the key (128 or 256 bits)
-> nonce | the nonce (64 or 96 bits)
-> State | the initial ChaCha state

Initialize a new ChaCha context with the number of rounds, the key and the nonce associated.

combine #

Arguments

:: ByteArray ba |
=> State | the current ChaCha state
-> ba | the source to xor with the generator
-> (ba, State) |

Combine the chacha output and an arbitrary message with a xor, and return the combined output and the new state.

generate #

Arguments

:: ByteArray ba |
=> State | the current ChaCha state
-> Int | the length of data to generate
-> (ba, State) |

Generate a number of bytes from the ChaCha output directly

data State #

ChaCha context

Instances

NFData State # |
Methods rnf :: State -> () #

# simple interface for DRG purpose

initializeSimple #

Arguments

:: ByteArray seed |
=> seed | a 40 bytes long seed
-> StateSimple |

Initialize simple ChaCha State

generateSimple :: ByteArray ba => StateSimple -> Int -> (ba, StateSimple) #

similar to `generate` but assume certains values

data StateSimple #

ChaCha context for DRG purpose (see Crypto.Random.ChaChaDRG)

Instances

NFData StateSimple # |
Methods rnf :: StateSimple -> () #